#ifndef FILE_FIRE_SEEN
#define FILE_FIRE_SEEN

#define MAX_X               80
#define MAX_Y               80
#define MAX_COORD           MAX_X*MAX_Y
#define GREEN_TREE          0
#define BURN_STEPS          5
#define BLACK_TREE          GREEN_TREE+BURN_STEPS
/* Coordinate for out of bounds */
#define OOB                 -1

/* #define DEBUG               1 */

#define _ISOC99_SOURCE      1
#define _GNU_SOURCE         1
#define _XOPEN_SOURCE       1

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdbool.h>
#include <curses.h>

extern char *program_invocation_short_name;

typedef struct user_args user_args;
struct user_args {
    float       burn_ratio;
};

/* Neighbors for grassy field, will be OOB if they are off the grid */
typedef struct neighbors neighbors;
struct neighbors {
    int up;
    int down;
    int left;
    int right;
};

/* Field of grass and rabbits */
typedef struct forest forest;
struct forest {
    short unsigned int tree;
    struct neighbors neighbors;
};

void usage();

struct user_args get_user_args(const int,char **);

struct forest *init_forest(
        const struct user_args,
        struct drand48_data *
        );

int burn_trees(
        const struct user_args,
        struct forest *,
        struct forest *,
        struct drand48_data *,
        WINDOW *
        );

unsigned short int burn_neighbors(
        const struct user_args,
        struct forest *,
        struct forest *,
        const unsigned int, /* index */
        struct drand48_data *
        );

unsigned int calc_2d21d(
        const unsigned int, /* dim */
        const unsigned int, /* x */
        const unsigned int  /* y */
        );

void print_forest(
        const struct forest *,
        WINDOW *
        );

#endif /* !FILE_FIRE_SEEN */
