#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <curses.h>
#include "fire.h"

int main(int argc,char **argv) {
    struct user_args args;
    struct forest *burning_forest;
    struct forest *next_burning_forest;
    struct drand48_data rand_buffer;
    WINDOW *curses;

    args = get_user_args(argc,argv);

    if((curses = initscr()) == NULL) {
        fprintf(stderr,"curses initialization failed\n");
        exit(EXIT_FAILURE);
    }

    box(curses,0,0);

#ifdef DEBUG
    fprintf(stderr,"Max coord in %d\n",MAX_COORD);
    fprintf(stderr,"Initiaizling drand48 buffer\n");
#endif
    srand48_r((time(NULL)+getpid()), &rand_buffer);

    if((burning_forest = init_forest(args,&rand_buffer)) == NULL) {
        fprintf(stderr,"Forest initialization failed\n");
        abort();
    }
    if((next_burning_forest = init_forest(args,&rand_buffer)) == NULL) {
        fprintf(stderr,"Next forest initialization failed\n");
        abort();
    }

    if((burn_trees(args,burning_forest,next_burning_forest,&rand_buffer,curses))
            < 0) {
        fprintf(stderr,"Burning forest failed\n");
        exit(EXIT_FAILURE);
    }

    free(next_burning_forest);
    free(burning_forest);
    delwin(curses);
    endwin();
    refresh();

    exit(EXIT_SUCCESS);
}
